#include <iostream>
#include <string>
#include <list>

using namespace std;

class B {
private:
	int id;
public:
	B(int i) : id(i) {cout << "Contructor de B" << endl; };
	int obtener_id() const { return id; }

	void imprime(string s) const {
		cout << "Clase B: " << s << endl;
	}

	void imprime(double d) const {
		cout << "Clase B: " << d << endl;
	}
};

class D: public B {
private:
	double val;
public:
	using B::imprime;
	D(int i, double v) : B(i), val(v) {cout << "Contructor de D" << endl; };
	void aux() const {
		// cout << id << endl; // error de compilación
		cout << obtener_id() << endl;
	}

	void imprime(string s) const {
		// primero llamamos a método de base
		B::imprime(s);
		cout << "Clase D: " << s << endl;
	}
};

void imprime_lista(list<B *> & lista) {
	list<B *>::const_iterator i;

	for (i=lista.begin(); i!=lista.end(); ++i)
		(*i)->imprime("Objeto");
}

int main() {
	B b(1);
	D d(2, 3.0);
	cout << "Objeto b ocupa " << sizeof(b) << endl;
	cout << "Objeto d ocupa " << sizeof(d) << endl;

	// cout << d.id << endl; // error de compilación
	cout << d.obtener_id() << endl;
	d.aux();

	b.imprime("Objeto b");
	d.imprime("Objeto d");

	d.imprime(7.5);

	B bb(3);
	D dd(4, 4.4);

	//dd=b; // error de compilación: un objeto B no es clase D
	bb=d; // OK, pero se produce "slicing"

	B * pb;
	D * pd;

	//pd=&b; // error de compilación: un objeto B no es clase D
	pb=&d; // OK

	pb=&d;
	//pd=pb; // error de compilación, aunque conceptualmente correcto
	
	pb=&b;
	pb->imprime("Puntero a B apuntando a objeto B");
	pb->obtener_id();

	pd=&d;
	pd->imprime("Puntero a D apuntando a objeto D");
	pd->obtener_id();

	pb=&d;
	pb->imprime("Puntero a B apuntando a objeto D");
	pb->obtener_id();

	list<B *> lista;

	B b1(5);
	D d1(6, 6.6);
	B b2(7);
	D d2(8, 8.8);
	lista.push_back(&b1);
	lista.push_back(&d1);
	lista.push_back(&b2);
	lista.push_back(&d2);

	imprime_lista(lista);
	return 0;
}

