#include <iostream>
#include <string>
using namespace std;

// -----------------------   Persona  -----------------------------------
class Persona {
private:
	string apellido1;
	string apellido2;
	string nombre;
	int DNI;
	string estado_civil;
public:
	Persona(string a1="", string a2="", string n="",
	    int id=0, string e=""):
		apellido1(a1), apellido2(a2), nombre(n), DNI(id),
		estado_civil(e) {}
	void cambiar_estado_civil(string e);
	void imprimir() const;
};

void Persona::cambiar_estado_civil(string e) {
	estado_civil = e;
}

void Persona::imprimir() const{
	cout << "Datos personales" << endl;
	cout << "\tNombre y apellidos: " << nombre << " " <<
		apellido1 << " " << apellido2 << " " << endl;
	cout << "\tDNI: " << DNI << endl;
	cout << "\tEstado civil: " << estado_civil << endl;
}

// -----------------------   Estudiante  -----------------------------------
class Estudiante: public Persona {
private:
	int curso;
public:
	Estudiante(string a1="", string a2="", string n="",
	    int id=0, string e="", int c=0):
		Persona(a1, a2, n, id, e), curso(c) {}
	void imprimir() const;
	void cambiar_curso(int c);
};

void Estudiante::imprimir() const{
	Persona::imprimir();
	cout << "Datos academicos" << endl;
	cout << "\tCurso: " << curso << endl;
}

void Estudiante::cambiar_curso(int c) {
	curso=c;
}

// -----------------------   Empleado  -----------------------------------
class Empleado: public Persona {
private:
	int fecha_alta;
	int despacho;
public:
	Empleado(string a1="", string a2="", string n="",
	    int id=0, string e="", int fa=1900, int d=0):
		Persona(a1, a2, n, id, e), fecha_alta(fa), despacho(d) {}
	void imprimir() const;
	void cambiar_despacho(int d);
};

void Empleado::imprimir() const{
	Persona::imprimir();
	cout << "Datos del trabajador" << endl;
	cout << "\tFecha de alta: " << fecha_alta << endl;
	cout << "\tDespacho: " << despacho << endl;
}
void Empleado::cambiar_despacho(int d) {
	despacho=d;
}

// -----------------------   Profesor  -----------------------------------
class Profesor: public Empleado {
private:
	string dpto;
public:
	Profesor(string a1="", string a2="", string n="",
	    int id=0, string e="", int fa=1900, int d=0, string dep=""):
		Empleado(a1, a2, n, id, e, fa, d), dpto(dep) {}
	void imprimir() const;
	void cambiar_dpto(string dep);
};

void Profesor::imprimir() const{
	Empleado::imprimir();
	cout << "Datos laborales" << endl;
	cout << "\tDepartamento: " << dpto << endl;
}

void Profesor::cambiar_dpto(string dep) {
	dpto=dep;

}

// -----------------------   PAS  -----------------------------------
class PAS: public Empleado {
private:
	string seccion;
public:
	PAS(string a1="", string a2="", string n="",
	    int id=0, string e="", int fa=1900, int d=0, string s=""):
		Empleado(a1, a2, n, id, e, fa, d), seccion(s) {}
	void imprimir() const;
	void cambiar_seccion(string sec);
};

void PAS::imprimir() const{
	Empleado::imprimir();
	cout << "Datos laborales" << endl;
	cout << "\tSección: " << seccion << endl;
}

void PAS::cambiar_seccion(string sec) {
	seccion=sec;

}

// -----------------------   main  -----------------------------------

int main () {
	// Persona p; // error de compilacion
	//Empleado e; // error de compilacion
	Estudiante e1("Martinez", "Gomez", "Juan", 12345678, "soltero", 3);
	Profesor p1("Garcia", "Perez", "Luisa", 87654321, "divorciado",
		2000, 511, "Matematicas");
	PAS s1("Fernandez", "Lopez", "Maria", 8888888, "viudo",
		1990, 111, "Biblioteca");

	e1.imprimir();
	e1.cambiar_curso(5);
	e1.cambiar_estado_civil("casado");
	e1.imprimir();

	p1.imprimir();
	p1.cambiar_despacho(513);
	p1.cambiar_dpto("Inteligencia artificial");
	p1.cambiar_estado_civil("casado");
	p1.imprimir();

	s1.imprimir();
	s1.cambiar_despacho(113);
	s1.cambiar_seccion("Secretaria");
	s1.cambiar_estado_civil("casado");
	s1.imprimir();

	return 0;
}
